package com.tzld.piaoquan.recommend.server.dataloader;

import com.aliyun.odps.data.Record;
import com.aliyun.odps.tunnel.io.TunnelRecordReader;
import com.tzld.piaoquan.recommend.server.common.ThreadPoolFactory;
import com.tzld.piaoquan.recommend.server.common.base.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import java.util.concurrent.ExecutorService;


@Component
public class UserFeatureToRedisLoader {

    @Autowired
    private RedisTemplate<String, String> redisTemplate;
    private final String userKeyFormat = "user:%s";
    private ExecutorService pool = ThreadPoolFactory.defaultPool();


    public void loadFeatureToRedis(String userTable, String dt) {
        String sql = String.format("select * from %s where dt ='%s';", userTable, dt);
        TunnelRecordReader reader = FeatureConstructor.loadDataFromOSSSession(sql, userTable, dt);
        Record record;
        Map<String, String> userFeaRedisFormat = new HashMap<String, String>();
        int count = 0;
        try {
            while ((record = reader.read()) != null) {
                UserFeature userFeature = FeatureConstructor.constructUserFeature(record);
                String key = String.format(userKeyFormat, userFeature.getKey());
                String value = userFeature.getValue();
                userFeaRedisFormat.put(key, value);
                if(count < 10000) {
                    count++;
                } else if (count == 10000) {
                    redisTemplate.opsForValue().multiSet(userFeaRedisFormat);
                    userFeaRedisFormat = new HashMap<String, String>();
                    count = 0;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }



    public static void main(String[] args) {
        if(args.length < 2){
            System.out.println("--------args 缺失---------");
            return;
        }
        UserFeatureToRedisLoader userFeatureToRedisLoader = new UserFeatureToRedisLoader();
        userFeatureToRedisLoader.loadFeatureToRedis(args[0], args[1]);
    }

}
